unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls,Clipbrd, DB, DBTables, DBCtrls, Grids,
  DBGrids, jpeg, Menus, ImgList;

type
  TfrmForca = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Panel1: TPanel;
    Edit2: TEdit;
    BitBtn2: TBitBtn;
    Panel2: TPanel;
    imForca: TImage;
    imCabeca: TImage;
    imBracos: TImage;
    imCorpo: TImage;
    imPernas: TImage;
    imOlhos: TImage;
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    NovoJogo1: TMenuItem;
    N1: TMenuItem;
    Sair1: TMenuItem;
    Sobre1: TMenuItem;
    Sobre2: TMenuItem;
    ImageList1: TImageList;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure NovoJogo;
    procedure BitBtn2Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Sobre2Click(Sender: TObject);
    procedure NovoJogo1Click(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmForca: TfrmForca;
  L:integer;
  Letra:Array[0..20] of TLabel;
  j,s,n:integer;
  OPC,a,b,c,Nome:String;
  Alfabeto:Array[0..26] of TLabel;
  t,p,Alf:Integer;
  Encontra:Boolean;
  
implementation

{$R *.dfm}
Procedure TfrmForca.NovoJogo;
begin
        imCabeca.Visible:=False;
        imCorpo.Visible:=False;
        imBracos.Visible:=False;
        imPernas.Visible:=False;
        ImOlhos.Visible:=False;
      For t:=1 to n do begin
        Letra[t].Caption:='';
      end;
  randomize;
  L:= random(Memo1.Lines.Count);
  n:=Length(Memo1.Lines.Strings[L]);
  Nome:= UpperCase(Memo1.Lines.Strings[L]);
  j:=n;
for Alf:=1 to n do begin
  Alfabeto[Alf]:=TLabel.Create(Self);
With Alfabeto[Alf] do begin
      Top:=20;
      Font.Name:='Arial';
      Parent:=Panel2;
      Font.Size:=14;
      Font.Color:=clBlue;
      Left:= 10 * (Alf * 2);
      Alignment:=taCenter;
      Caption:='__';
end;
  P:=0;
end;
  Label2.Caption:='Total de Letras: ' + IntToStr(n);
  For s:=1 to n do begin
    Letra[s]:=TLabel.Create(Self);
    Letra[s].Parent:=Panel1;
    Letra[s].Caption:='_';
    Letra[s].Font.Style:=[fsBold];
    Letra[s].Font.Name:='Arial';
    Letra[s].Font.Color:=clRed;
    Letra[s].Font.Size:=16;
    Letra[s].Left:= 12 * (s * 3);
    Letra[s].Top:= 36;
  end;
  Label1.Caption:=Nome + ' -- ' + IntToStr(n);
end;
procedure TfrmForca.FormCreate(Sender: TObject);
begin
  NovoJogo;
end;
procedure TfrmForca.BitBtn2Click(Sender: TObject);
begin
  NovoJogo;
end;

procedure TfrmForca.Edit2KeyPress(Sender: TObject; var Key: Char);
var
  Lx:String;
begin
If not( key in['a'..'z',#8,#13,'A'..'Z',' '] ) then
  begin
  beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;

if key = #13 then begin
begin
  if Trim(Edit2.Text) = '' then begin
    Edit2.Clear;
    Edit2.SetFocus;
    Abort;
  end;
  Encontra:=False;
  OPC:=Edit2.Text;
for t:=1 to n do begin
  Lx:=Copy(Nome, t, 1);
  if OPC = Letra[t].Caption then begin
    ShowMessage('Letra ja saiu');
    Abort;
  end;
  if Lx = OPC then begin
    Encontra:=True;
    Letra[t].Caption:=UpperCase(Lx);
    Dec(j);
    If j = 0 then begin
      ShowMessage('Parabens! Voc acaba de ganhar!');
      NovoJogo;
    end;
  end;
end;
      if Encontra = False then begin
        Inc(p);
        Case p of
        1:imCabeca.Visible:=True;
        2:imCorpo.Visible:=True;
        3:imBracos.Visible:=True;
        4:imPernas.Visible:=True;
        5:ImOlhos.Visible:=True;
        6:Begin
          ShowMessage('Infelizmente voc acaba de perder!'+ #13 +
                      'Tente novamente!' + #13 + #13 + 
                      'A palavra era: ' + Nome);
          NovoJogo;
          end;
        end;
        Alfabeto[p].Caption:=UpperCase(OPC);
      end;
end;
end;
  Edit2.Clear;
  Edit2.SetFocus;
end;

procedure TfrmForca.Sobre2Click(Sender: TObject);
begin
ShowMessage(
  'Jogo da Forca.' + #13+
  'Epaminondas (Junior) '+ #13 +
  'tapegado@hotmail.com'+ #13 +
  '0**84 9910-4765');
end;

procedure TfrmForca.NovoJogo1Click(Sender: TObject);
begin
  NovoJogo;
end;

procedure TfrmForca.Sair1Click(Sender: TObject);
begin
Close;
end;

procedure TfrmForca.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if MessageDlg('Deseja realmente sair?',mtCustom,[mbOk,mbCancel],0) <> IDOK then Abort;
end;

end.
